import java.awt.*;
import java.awt.event.*;
import java.awt.Color.*;
import java.awt.Graphics;
import java.util.*;
import java.io.*;

public class JacoGraph extends Canvas implements  Runnable { 
  static  int		IterNum = 10;

  private Thread	thread;	
  private MenuBar	mb;
  private Menu		closeMenu;
  private MenuItem	closeItem;
  private int		rectSize = 32; //small rectangle size

  private Graphics gfloor;

  private int [] colorDat ;

  static int LENGTH = 16,  WIDTH = 16;

  static  float		Jcolor[][] = new float[LENGTH][WIDTH];
  public static int ColorArray_R[][] = new int[LENGTH][WIDTH];
  public static int ColorArray_G[][] = new int[LENGTH][WIDTH];
  public static int ColorArray_B[][] = new int[LENGTH][WIDTH];

  public void start() 
  {
   if(thread == null){
      thread = new Thread(this);
      thread.start();
    }
  }

  public int currentRectSize()
  { return this.rectSize;}

  public void setRectSize(int newsize)
  {
    this.rectSize = newsize;
  }

  public void stop() {
    if(thread != null){
      thread.stop();
      thread = null;
    }
  } //Override deprecated method

  public void run() {
    while(thread != null){
      repaint();
      // try {
        // Thread.sleep(100);
      // } catch (InterruptedException e) {
        // Do nothing
      // };
    }
  }

  public static void setGridSize(int len, int wid)
  { LENGTH = len;		WIDTH = wid; }

  /* public static void main(String args[])
  {
	Frame f = new JacoGraph("Jacobi Demo");
	Panel p = new Panel();
	
	p.setLayout(new FlowLayout());
	p.add(new Label("Jacobi Iteration"));
	// p.add(new Button(""));
	f.setLayout(new BorderLayout());
	f.add("North",p);
	// run();
	// f.pack();
	f.resize(600,600);
	f.show();
  } */

  public JacoGraph() // (String s) 
  {    
	// super(s);
	// setLayout(new BorderLayout());
    // MenuBar mb = new MenuBar();
    // Menu closeMenu = new Menu("Close");
    // MenuItem closeItem = new MenuItem("Close");
    // closeMenu.add(closeItem);
    // // closeItem.addActionListener(this);
    // setMenuBar(mb); 
    // mb.add(closeMenu);
	// init();
  }

  // public void actionPerformed(ActionEvent evt) 
  // {  
  //  MenuItem mi = (MenuItem) evt.getSource();
  //  String arg = mi.getLabel();
  //   if(arg.equals("Close"))
  //     setVisible(false);
  // }

  public void init() {
    /* for (int i=0; i < LENGTH; i++) {
      for (int j=0; j < WIDTH; j++) {
		if(i == 0 | j == 0 | i == LENGTH -1 | j == WIDTH -1){
        	ColorArray_R[i][j] = 255;
        	ColorArray_G[i][j] = 0;
        	ColorArray_B[i][j] = 0;
		} else {
			ColorArray_R[i][j] = 0;
			ColorArray_G[i][j] = 0;
			ColorArray_B[i][j] = 0;
		}
      }
    } */
  }

   public void paint(Graphics g) 
   {
	int x = 100,y = 100;
    // if(Jacobi_h.ColorArray_R != null)
    if(colorDat != null)
    for (int i=0; i<LENGTH; i++) {
      for (int j=0; j<WIDTH; j++) {
		g.setColor(new Color(colorDat[i*WIDTH + j],0,0));
		// g.setColor(new Color(ColorArray_R[i][j],0,0));
		// colorDat[i];
		//Jacobi_h.ColorArray_R.dat()[i] = 1;
		//Jacobi_h.ColorArray_R.dat()[Jacobi_h.ColorArray_R.pos(i,j)] = 1;
		//new Color(Jacobi_h.ColorArray_R.dat()[Jacobi_h.ColorArray_R.pos(i,j)],0,0); 
		// g.setColor(new Color(Jacobi_h.ColorArray_R.dat()[Jacobi_h.ColorArray_R.pos(i,j)],0,0)); 
		// g.setColor(new Color(ColorArray_R[i][j],0,0));
        g.fillRect(x + i*rectSize, y + j*rectSize,rectSize,rectSize);
      }
    }
   }

  public void setClr(int[] clrArray)
  {
    colorDat = clrArray ;
    /* for (int i=1; i<LENGTH-1; i++)
      for (int j=1; j<WIDTH-1; j++) 
        ColorArray_R[i][j] = clrArray[i*WIDTH + j]; */
  }

  public void draw() { 
	// draw (int size) {
    // spinSize = size;
    repaint();
	// }
  }

  private Image offScreenImage;
  private Dimension offScreenSize;
  private Graphics offScreenGraphics;

  public final synchronized void update (Graphics g) {
    Dimension d = getSize();

    if((offScreenImage == null) || (d.width != offScreenSize.width) ||  
       (d.height != offScreenSize.height)) {
      offScreenImage = createImage(d.width, d.height);
      offScreenSize = d;
      offScreenGraphics = offScreenImage.getGraphics();
    }
    offScreenGraphics.clearRect(0, 0, d.width, d.height);
    paint(offScreenGraphics);
    g.drawImage(offScreenImage, 0, 0, null);
  }
} 
